﻿/* FormatElementViewModel.cs
 * part of zaaReloaded2
 * 
 * Copyright 2015 Daniel Kraus
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using zaaReloaded2.Controller.Elements;

namespace zaaReloaded2.ViewModels
{
    public class FormatElementViewModel : ElementViewModel
    {
        #region Public properties

        public string Content
        {
            [DebuggerStepThrough]
            get { return ((FormatElementBase)Element).Content; }
            set
            {
                ((FormatElementBase)Element).Content = value;
                OnPropertyChanged("Content");
            }
        }

        /// <summary>
        /// Gets or sets the parent ControlElementViewModel, if
        /// there is any.
        /// </summary>
        public ControlElementViewModel Parent { get; set; }

        #endregion

        #region Constructors

        public FormatElementViewModel() : base() { }

        public FormatElementViewModel(FormatElementBase formatElement)
            : this()
        {
            Element = formatElement;
        }

        #endregion

        public override object Clone()
        {
            FormatElementViewModel clone = new FormatElementViewModel();
            clone.Parent = Parent;
            clone.Element = Element;
            return clone;
        }
    }
}
